// Pickin' Sticks Arcade, Rachel J. Morris 2012
// https://github.com/Moosader/Pickin-Sticks-Arcade
// www.moosader.com
// Licensed TBD!

package com.moosader.entities;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.Texture.TextureFilter;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.math.Vector2;

public class Item extends EntityBase {
	
	public Item() { setup(); }
	
	public void setup()
	{
		m_coord = new Vector2( 64, 64 );
		m_dimen = new Vector2( 32, 32 );
		
		m_texture = new Texture(Gdx.files.internal("data/gfx/wipsticks.png"));
		m_texture.setFilter(TextureFilter.Linear, TextureFilter.Linear);
		
		m_sprite = new Sprite(new TextureRegion(m_texture, 0, 0, 128, 128));
		m_sprite.setPosition(m_coord.x, m_coord.y);
		m_sprite.setSize(m_dimen.x, m_dimen.y);
		
		generateNewCoordinates();
	}
	
	public void generateNewCoordinates() {
		m_coord.x = (float) (Math.random() * (320 - m_dimen.x));
		m_coord.y = (float) (Math.random() * (320 - m_dimen.y));
		
		int sprite = (int)(Math.random() * 4);
		m_sprite.setRegion(sprite*128, 0, 128, 128);
	}
	
	public void update(float delta) {
		m_sprite.setPosition(m_coord.x, m_coord.y);
	}
}
