// Pickin' Sticks Arcade, Rachel J. Morris 2012
// https://github.com/Moosader/Pickin-Sticks-Arcade
// www.moosader.com
// Licensed TBD!

package com.moosader.entities;

import java.util.ArrayList;
import java.util.List;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.Texture.TextureFilter;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.moosader.screens.GameScreen;

// ToDo: Add more complex maps?
public class Map {
	private List<Tile> m_lstTiles;
	
	public Map() { setup(); }
	
	public void setup() {
		m_lstTiles = new ArrayList<Tile>();
		
		Texture textureTileset = new Texture(Gdx.files.internal("data/gfx/wipgrass.png"));
		textureTileset.setFilter(TextureFilter.Linear, TextureFilter.Linear);
		
		for ( int y = 0; y < 10; y++ )
		{
			for ( int x = 0; x < 10; x++ )
			{
				Tile newTile = new Tile();
				newTile.setup(x*32, y*32, 0, textureTileset);
				m_lstTiles.add(newTile);
			}
		}
	}
	
	public void pushTiles(GameScreen screen) {
		for (Tile t : m_lstTiles) {
			screen.addSprite(t.m_sprite);
		}
	}
}
