// Pickin' Sticks Arcade, Rachel J. Morris 2012
// https://github.com/Moosader/Pickin-Sticks-Arcade
// www.moosader.com
// Licensed TBD!

package com.moosader.mechanics;

import com.badlogic.gdx.math.Vector2;

// ToDo: Clean up
public class AcceleratingObject {
	public AcceleratingObject() {
		m_coord = new Vector2();
		m_dimen = new Vector2();
		m_velocity = new Vector2();
		m_maxVelocity = new Vector2();
	}
	
	public AcceleratingObject(float x, float y, float w, float h){
		m_coord = new Vector2();
		m_dimen = new Vector2();
		m_velocity = new Vector2();
		m_maxVelocity = new Vector2();
		m_isMoving = false;
		setRectangle(x, y, w, h);
	}
	
	public void move(float delta) {
		m_coord.x += delta * (int)(m_velocity.x);
		m_coord.y += delta * (int)(m_velocity.y);	
		
		adjustVelocity();
	}
	
	private void adjustVelocity() {

		// Decrease velocity
		if (!m_isMoving){
			if ( m_velocity.x <= -1) {
				m_velocity.x += m_deaccelerationSpeed;
			}
			else if ( m_velocity.x >= 1 ) {
				m_velocity.x -= m_deaccelerationSpeed;
			}
			if ( m_velocity.y <= -1 ) {
				m_velocity.y += m_deaccelerationSpeed;
			}
			else if ( m_velocity.y >= 1 ) {
				m_velocity.y -= m_deaccelerationSpeed;
			}
		}		
	}
	
	public void reverseVelocityX() { 
		m_velocity.x = -m_velocity.x;
	}
	
	public void reverseVelocityY() {
		m_velocity.y = -m_velocity.y;
	}
	
	public void move(int xAmount, int yAmount) {
		m_isMoving = true;
		
		// Increase Velocity
		m_velocity.x += xAmount * m_accelerationSpeed;
		m_velocity.y += yAmount * m_accelerationSpeed;
		
		// Adjust velocity
		if ( m_velocity.x > m_maxVelocity.x ) {
			m_velocity.x = m_maxVelocity.x;
		}
		else if ( m_velocity.x < -m_maxVelocity.x ) {
			m_velocity.x = -m_maxVelocity.x;
		}
		
		if ( m_velocity.y > m_maxVelocity.y ) {
			m_velocity.y = m_maxVelocity.y;
		}
		else if ( m_velocity.y < -m_maxVelocity.y ) {
			m_velocity.y = -m_maxVelocity.y;
		}
		
		if ( m_velocity.x > -1 && m_velocity.x < 1 ) {
			m_velocity.x = 0;
		}
		if ( m_velocity.y > -1 && m_velocity.y < 1 ) {
			m_velocity.y = 0;
		}
	}
	
	public void setRectangle(float x, float y, float w, float h) {
		m_coord.x = x;
		m_coord.y = y;
		m_dimen.x = w;
		m_dimen.y = h;
	}
	
	public void setSpeeds(Vector2 maxVelocity, float accSpeed, float deaccSpeed) {
		m_maxVelocity = maxVelocity;
		m_accelerationSpeed = accSpeed;
		m_deaccelerationSpeed = deaccSpeed;
	}
	
	public Vector2 getCoordinates() {
		return m_coord;
	}
	
	public void setCoordinates(float x, float y) {
		m_coord.x = x;
		m_coord.y = y;
	}
	
	public void setIsMoving(boolean val) { m_isMoving = val; }
	
	public boolean getIsMoving() { return m_isMoving; }

	public float getX() { return m_coord.x; }
	public float getY() { return m_coord.y; }
	
	public float getLeft() { return m_coord.x; }
	public float getRight() { return m_coord.x + m_dimen.x; }
	public float getTop() { return m_coord.y + m_dimen.y; }
	public float getBottom() { return m_coord.y; }
	
	public Vector2 getDimensions() { 
		return m_dimen;
	}
	
	public float getWidth() { return m_dimen.x; }
	public float getHeight() { return m_dimen.y; }
	
	protected Vector2 m_coord;
	protected Vector2 m_dimen;
	
	protected Vector2 m_velocity;
	protected Vector2 m_maxVelocity;
	
	protected float m_accelerationSpeed;
	protected float m_deaccelerationSpeed;
	
	protected boolean m_isMoving;
}
