// Pickin' Sticks Arcade, Rachel J. Morris 2012
// https://github.com/Moosader/Pickin-Sticks-Arcade
// www.moosader.com
// Licensed TBD!

package com.moosader.pickinsticks;

import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import com.moosader.states.BaseState;
import com.moosader.states.ClassicGameState;
import com.moosader.states.TitleState;

public class PickinSticksArcade extends Game {
	private BaseState currentScreen; 
	private ClassicGameState levelScreen;
	private TitleState titleScreen;
	
	@Override
	public void create() {	
		levelScreen = new ClassicGameState();
		titleScreen = new TitleState();
		currentScreen = titleScreen;
	}

	@Override
	public void dispose() {
	}

	@Override
	public void render() {
		currentScreen.update(Gdx.graphics.getDeltaTime());
		currentScreen.render(Gdx.graphics.getDeltaTime());
		
		if (currentScreen.isDone()) {
			currentScreen.dispose();	
			currentScreen = levelScreen;
			// Switch states
		}
	}

	@Override
	public void resize(int width, int height) {
		currentScreen.resize(width, height);
	}

	@Override
	public void pause() {
	}

	@Override
	public void resume() {
	}
	
	@Override
	public BaseState getScreen() {
		return (BaseState)super.getScreen();
	}
}
