// Pickin' Sticks Arcade, Rachel J. Morris 2012
// https://github.com/Moosader/Pickin-Sticks-Arcade
// www.moosader.com
// Licensed TBD!

package com.moosader.states;

import java.util.ArrayList;

import com.badlogic.gdx.Screen;
import com.badlogic.gdx.graphics.g2d.Sprite;

//
public abstract class BaseState implements Screen	 {
	public abstract void update(float delta);
	public abstract void draw(float delta);
	
	public boolean m_isDone;
	
	public boolean isDone() { return m_isDone; }
	
	@Override
	public void render(float delta){
		update(delta);
		draw(delta);
	}
	
	@Override
	public abstract void resize(int width, int height);
	
	@Override
	public void show() {
	}
	
	@Override
	public void hide() {
	}
	
	@Override
	public void pause() {
	}
	
	@Override
	public void resume() {
	}
	
	@Override
	public void dispose() {
	}
}
