// Pickin' Sticks Arcade, Rachel J. Morris 2012
// https://github.com/Moosader/Pickin-Sticks-Arcade
// www.moosader.com
// Licensed TBD!

package com.moosader.states;

import java.util.ArrayList;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input.Keys;
import com.badlogic.gdx.graphics.GL10;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.Texture.TextureFilter;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;

public class TitleState extends BaseState {	
	public Texture m_titleScreenTexture;
	public Sprite m_titleScreen;
	private SpriteBatch m_batch;
	private ArrayList<Sprite> m_lstSprites; 
	
	public TitleState() { setup(); }
	
	public void setup() {
		m_isDone = false;
		m_lstSprites = new ArrayList<Sprite>();
		m_batch = new SpriteBatch();
		
		m_titleScreenTexture = new Texture(Gdx.files.internal("data/gfx/WIP_Title.png"));
		m_titleScreenTexture.setFilter(TextureFilter.Linear, TextureFilter.Linear);

		m_titleScreen = new Sprite(new TextureRegion(m_titleScreenTexture,
				0, 0, 800, 480));
		m_titleScreen.setSize(Gdx.graphics.getWidth(), Gdx.graphics.getHeight());
	}

	@Override
	public void update(float delta) {
		if (Gdx.input.isKeyPressed(Keys.ANY_KEY) || Gdx.input.isTouched()) {
			m_isDone = true;
		}
		
		m_lstSprites.clear();
		m_lstSprites.add( m_titleScreen );
	}
	
	@Override
	public void resize(int width, int height) {
		
	}

	@Override
	public void draw(float delta) {		
		Gdx.gl.glClearColor(0.5f, 0.5f, 0.5f, 1);
		Gdx.gl.glClear(GL10.GL_COLOR_BUFFER_BIT);
		
		m_batch.begin();
		for (Sprite s : m_lstSprites)
		{
			s.draw(m_batch);
		}
		m_batch.end();	
	}

}
